<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #page {
            height: 100vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 70rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body onload="getCurrentUser()">
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <label for="sender">From:</label>
            <input type="text" id="senderField" name="senderField" readonly>
            <button type="button" id="sendBtn">Send</button>
            <button type="button" id="logoutBtn">Log out</button>
            <label for="receiver">To:</label>
            <input type="text" id="receiver" name="receiver" placeholder="Message receiver(s), split by comma and whitespace, e.g. ', '">
            <span></span>
            <span></span>
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;" placeholder="Write your message here..."></textarea>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('senderField');
    var messageField = document.getElementById('message');
    var receiverField = document.getElementById('receiver')
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var logoutBtn = document.getElementById('logoutBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = "Message + query: " + query;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (sender, message, receiver) => {
        const id = reqId++;
        const q = `/send?sender=${encodeURIComponent(sender)}&message=${encodeURIComponent(message)}&receiver=${encodeURIComponent(receiver)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = "From: " + sender + " To: " + receiver;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    async function getCurrentUser(){
        fetch('/logged_in_user',  {method: 'GET'})
        .then(function (response) {
            return response.json();
        }).then(function (text) {
            senderField.value = text.txt; 
        });
    }

    var logout = async() =>{
        const q = '/logout';
        wait = await fetch(q);
        document.location.reload();
    };

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });
    searchBtn.addEventListener('click', () => search(searchField.value));
    logoutBtn.addEventListener('click', () => logout());
    allBtn.addEventListener('click', () => search('*'));
    sendBtn.addEventListener('click', () => send(senderField.value, messageField.value, receiverField.value));
    checkAnnouncements();
</script>

</html>